#include <bits/stdc++.h>
using namespace std;

const long long MAX_N = 1e6 + 10;

bool sugl(char c) {
    if(c == 'a' || c == 'e' || c == 'i' || c =='o' || c == 'u') {
        return false;
    }
    return true;
}
long long tree[2 * MAX_N];

long long val(long long a) {
    long long ret = 0;
    while(a > 0) {
        //cout << tree[a] << endl;
        ret = max(tree[a], ret);
        a -= a & (-a);
    }
    return ret;
}

void update(long long a, long long x) {
    while(a <= 2 * MAX_N) {
        tree[a] = max(tree[a], x);
        a += a & (-a);
    }
}

vector<pair<int, int> > ots;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    for(int i = 0; i < n; i ++) {
        int a, b;
        cin >> a;
        ots.push_back({a, -1});
    }
    for(int i = 0; i < n; i ++) {
        int a, b;
        cin >> b;
        ots[i].second = b;
    }
    sort(ots.begin(), ots.end());
    int ans = 0;
    for(int i = 0; i < n; i ++) {
        int curr = val(ots[i].second) + 1;
        update(ots[i].second, curr);
        ans = max(ans, curr);
//        cout << curr << endl;
    }
    cout << ans;
}
