#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 5e3 + 10;
int l[MAX_N], r[MAX_N], par[MAX_N];

const double ednaTreta = 0.33333333333333;
const double dveTreti = 0.66666666666666;
vector<double> masiv;

int dfs(int curr) {
    if(l[curr] == -1) {
        return par[curr] = 1;
    }
    return par[curr] = dfs(l[curr]) + dfs(r[curr]);
}

double solve(int curr, int left) {
    if(par[curr] < left) {
        return 0;
    }
    if(l[curr] == -left) {
        return 1;
    }
    if(left == 0) {
        return 0;
    }
    double mxAns = 0;
    for(int i = 0; i <= par[l[curr]] && i <= left; i ++) {
        double a, b;
        a = solve(l[curr], i);
        b = solve(r[curr], left - i);
        mxAns = max(mxAns, dveTreti * max(a, b) + ednaTreta * min(a, b));
    }
    //cout << curr << " " << left << " " << mxAns << endl;
    return mxAns;

}

void chance(int curr, double curch) {
    if(l[curr] == -1) {
        masiv.push_back(curch);
        return;
    }
    chance(l[curr], curch * dveTreti);
    chance(r[curr], curch * ednaTreta);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= n; i ++) {
        cin >> l[i];
        if(l[i] != -1) {
            cin >> r[i];
        }
    }
    dfs(1);
    if(par[l[1]] == par[r[1]]) {
        chance(1, 1);
        sort(masiv.begin(), masiv.end());
        double ans = 0.0;
        for(int i = masiv.size() - 1; i >= masiv.size() - m; i --) {
            ans += masiv[i];
        }
        cout << setprecision(8) << ans;
    } else {
        cout << setprecision(10) << solve(1, m);
    }
}
