#include<bits/stdc++.h>
#define db(x) cout<<#x<<": "<<x<<endl
using namespace std;

const double LR=2.0/3.0, RR=1.0/3.0;
double lvs[5005];
int n, m, lvsL=0;

struct Node{
    int l;
    int r;
    int lvsL;
    int lvsR;
    int lvs;
    double prob;
};

Node tree[5005];

bool xX_Thot_Slayer_Xx(double a, double b){
    return a>b;
}

string getO(double n, int pr){
    string o="0.";
    for(int i=0;i<pr;i++){
        n*=10;
        o+=to_string(int(n)%10);
    }
    return o;
}

int findLeaves(int root){
    //db(root);
    //db(tree[root].l);
    //db(tree[root].r);
    if(tree[root].l==-1&&tree[root].r==-1){
        return 1;
    }
    tree[root].lvsL=findLeaves(tree[root].l);
    tree[root].lvsR=findLeaves(tree[root].r);
    tree[root].lvs=tree[root].lvsL+tree[root].lvsR;
    return tree[root].lvs;
}

void findProb(int root, double prob){
    tree[root].prob=prob;
    if(tree[root].l==-1&&tree[root].r==-1){
        lvs[lvsL++]=prob;
        return;
    }
    double lp=LR, rp=RR;
    if(tree[root].lvsL>tree[root].lvsR){
        swap(lp, rp);
    }
    findProb(tree[root].l, prob*lp);
    findProb(tree[root].r, prob*rp);
}

int main(){
    cout<<2.0/3.0+(2.0/3.0)*(1.0/3.0);
    cout<<fixed;
    cout<<setprecision(9);
    cin>>n>>m;
    for(int i=0;i<n;i++){
        int l, r;
        cin>>l;
        if(l==-1){
            tree[i].l=-1;
            tree[i].r=-1;
            continue;
        }
        cin>>r;
        l--;r--;
        tree[i].l=l;
        tree[i].r=r;
    }

    findLeaves(0);
    //cout<<"Wet ";
    findProb(0, 1.0);
    //cout<<"biscuit "<<endl;

    sort(lvs, lvs+lvsL, xX_Thot_Slayer_Xx);
    double o=0;
    for(int i=0;i<m;i++){
        //db(i);
        //db(lvs[i]);
        o+=lvs[i];
    }
    cout<<o<<endl;
}
/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/

