#include<iostream>
#include<algorithm>
#include<math.h>
#include<vector>
#include<string>
#include<queue>
#include<stack>

using namespace std;

class node
{
public:
    int l;
    int r;
    int parent = -1;
    bool isLeaf = false;
    double chance = 0;
    bool isLeft = false;
};

node a[5005];

bool sorter(node a,node b)
{
    return a.chance > b.chance;
}

queue<int> visitNext;

int main()
{
    int n,m,p,nodeNow = 1,br = 0;
    double zb = 0;
    cin>>n>>m;
    a[1].chance = 1;
    for(int i = 1;i <= n;i++)
    {
        cin>>p;
        if(p != -1)
        {
            a[i].l = p;
            a[p].parent = i;
            a[p].isLeft = true;
            cin>>a[i].r;
            a[a[i].r].parent = i;
        }
        else
        {
            a[i].isLeaf = true;
        }
    }

    visitNext.push(a[1].l);
    visitNext.push(a[1].r);

    while(!visitNext.empty())
    {
        nodeNow = visitNext.front();
        visitNext.pop();
        //cout<<nodeNow<<" "<<a[a[nodeNow].parent].chance<<endl;
        if(a[nodeNow].isLeft)
        {
            a[nodeNow].chance = a[a[nodeNow].parent].chance * 0.666666666666;
        }
        else
        {
            a[nodeNow].chance = a[a[nodeNow].parent].chance * 0.333333333333;
        }
        if(!a[nodeNow].isLeaf)
        {
            visitNext.push(a[nodeNow].l);
            visitNext.push(a[nodeNow].r);
        }
    }

    sort(a,a + n,sorter);

    for(int i = 0;i <= n;i++)
    {
        if(a[i].isLeaf)
        {
            br++;
            zb += a[i].chance;
            if(br >= m)
            {
                break;
            }
        }
    }

    cout<<zb<<endl;
}
/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/
