#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
struct segment{
    int a;
    int b;
    int br;
};
vector <segment> reduced;
int n;
bool cmp(segment x, segment y)
{
    if (x.a<y.a) return true;
    return false;
}
void init()
{
    segment temp;
    int a, b;
    cin>>n;
    for (int i=0; i<n; i++){
        cin>>a;
        temp.a=a;
        temp.br=1;
        reduced.push_back(temp);
    }
    for (int i=0; i<n; i++){
        cin>>b;
        reduced[i].b=b;
    }
    sort(reduced.begin(), reduced.end(), cmp);
}
bool reduce()
{
    vector <segment> newReduced;
    segment temp;
    int reducedSize=reduced.size(), passed=0;
    /*cout<<"----------------------------"<<endl;
    for (int i=0; i<reducedSize; i++){
        cout<<"reduced["<<i<<"]: a = "<<reduced[i].a<<"; b = "<<reduced[i].b<<"; br = "<<reduced[i].br<<endl;
    }*/
    for (int i=1; i<reducedSize; i+=2){
        if (reduced[i-1].b<reduced[i].b){
            temp.a=reduced[i-1].a;
            temp.b=reduced[i].b;
            temp.br=reduced[i-1].br+reduced[i].br;
            newReduced.push_back(temp);
            passed+=2;
        }
        else {
            newReduced.push_back(reduced[i-1]);
            i--;
            passed++;
        }
    }
    if (passed!=reducedSize){
        newReduced.push_back(reduced[reducedSize-1]);
    }
    reduced=newReduced;
    if (newReduced.size()!=reducedSize) return true;
    return false;
}
int main()
{
    int maxBr=0, reducedSize;
    init();
    while (reduce());
    reducedSize=reduced.size();
    for (int i=0; i<reducedSize; i++){
        if (reduced[i].br>maxBr) maxBr=reduced[i].br;
    }
    /*for (int i=0; i<reducedSize; i++){
        cout<<"reduced["<<i<<"]: a = "<<reduced[i].a<<"; b = "<<reduced[i].b<<"; br = "<<reduced[i].br<<endl;
    }*/
    cout<<maxBr<<endl;

    return 0;
}
/**
4
12 8 2 5
4 2 3 6
*/
