#include<algorithm>
#include<iostream>
#include<utility>
using namespace std;

const int MAXN=10000;

pair<int,int> points[2*MAXN+5];
bool used[MAXN+5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for(int i=1; i<=2*n; i++)
    {
        cin >> points[i].first;
        points[i].second=(i>n?i-n:i);
    }
    sort(points+1,points+2*n+1);

    int m=0;
    int opened=0;
    for(int i=1; i<=2*n; i++)
    {
        if(!used[points[i].second])
        {
            opened++;
            used[points[i].second]=true;
        }
        else
        {
            opened--;
            m=max(m,opened);
        }
    }

    cout << m << endl;

    return 0;
}
