#include<iostream>
using namespace std;

bool kvadr(long long x)
{
    bool period[1000005];
    for(int i=0; i<1000005; i++) period[i]=false;
    long long sum;
    while(x!=1 and !period[x])
    {
        period[x]=true;
        sum=0;
        while(x!=0)
        {
            sum+=(x%10)*(x%10);
            x/=10;
        }
        x=sum;
    }
    if(x==1) return true;
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    long long A,B;
    cin >> A >> B;

    long long ans=0;
    for(long long i=A; i<=B; i++)
        if(kvadr(i)) ans++;

    cout << ans << endl;

    return 0;
}
