#include <iostream>
#include <algorithm>
#include <math.h>
#include <iomanip>

using namespace std;

const long long MAX_N = 1e8;

bool cmp(pair<int, int> rhs, pair<int, int> lhs)
{
    double chis1 = 0;
    double chis2 = 0;
    double znam1 = 0;
    double znam2 = 0;
    chis1 = pow(2, rhs.first);
    znam1 = pow(3, rhs.first + rhs.second);
    chis2 = pow(2, lhs.first);
    znam2 = pow(3, lhs.first + lhs.second);
    return chis1 * znam2 < chis2 * znam1;
}

int main()
{
    int n, m, k = 0;
    pair<int, int> chance[5010];
    pair<int, int> lista[5000];

    cin >> n >> m;
    chance[0].first = 0;
    chance[0].second = 0;
    for (int i = 0; i < n; ++ i)
    {
        int a, b;
        cin >> a;
        chance[a - 1].first = chance[i].first + 1;
        chance[a - 1].second = chance[i].second;
        if (a != -1)
        {
            cin >> b;
            chance[b - 1].first = chance[i].first;
            chance[b - 1].second = chance[i].second + 1;
        }
        else
        {
            lista[k].first = chance[i].first;
            lista[k].second = chance[i].second;
            ++ k;
        }
    }
    sort(lista + 0, lista + n, cmp);
    for (int i = 0; i < k; ++ i)
    {
        //cout << lista[i].first << " " << lista[i].second << endl;
    }
    int chislitel[5010];
    int znamenatel[5010];
    int l = 0;
    for (int i = k - 1; i >= k - m; -- i)
    {
        chislitel[l] = pow(2, lista[i].first);
        znamenatel[l] = pow(3, lista[i].first + lista[i].second);
        //cout << chislitel[l] << " " << znamenatel[l] << endl;
        ++ l;
    }
    double chis = 0;
    double znam = znamenatel[0];
    for (int i = 0; i < m - 1; ++ i)
    {
        if (znamenatel[i] == znamenatel[i + 1])
        {
            continue;
        }
        znam *= (znamenatel[i] * znamenatel[i + 1]) / __gcd(znamenatel[i], znamenatel[i + 1]);
    }
    //cout << znam << endl;
    for (int i = 0; i < m; ++ i)
    {
        chis += chislitel[i] * (znam / znamenatel[i]);
        //cout << chislitel[i] << " " << znam / znamenatel[i] << endl;
    }
    //cout << chis << endl;
    cout << setprecision(10) << (double)(chis / znam) << endl;
    return 0;
}
