#include <bits/stdc++.h>
using namespace std;
#define endl '\n';
///if time limit try unordered map
map<int, pair<int, int> > tree;
int arr[5001];
void dfs(int vertex, int value){
    if(tree.find(vertex) == tree.end()){
        arr[vertex] = value;
        return;
    }
    int left = tree[vertex].first, right = tree[vertex].second;
    dfs(left, (value << 1));
    dfs(right, value);
}
int log2(int number){
    int res = 0;
    while(number > 1){
     number >>= 1;
     ++res;
    }
    return res;
}
int cmp(int i, int j){
    return i > j;
}
int main(){
    cin.tie(0);
    ios::sync_with_stdio(false);
    int vertex, color;
    cin >> vertex >> color;
    for(int i = 0; i < vertex; ++i){
        int left, right;
        cin >> left;
        if(left == -1) continue;
        cin >> right;
        tree.insert({i + 1, {left, right}});
    }
    dfs(1, 1);
    sort(arr, arr + vertex, cmp);
    int sum = 0;
    for(int i = 0; i < color; ++i){
        sum += arr[i];
    }
    int log = log2(vertex);
    long double p = pow(3, log);
    cout << fixed;
    cout << setprecision(8);
   // cout << p << endl;
    cout << (long double)sum / p << endl;
    return 0;
}
