#include <bits/stdc++.h>
using namespace std;
#define endl '\n';
///if time limit try unordered map
map<int, pair<int, int> > tree;
vector<pair<int, int> > arr;
void dfs(int vertex, int value, int depth){
    if(tree.find(vertex) == tree.end()){
        arr.push_back({value, pow(3, depth)});
        return;
    }
    int left = tree[vertex].first, right = tree[vertex].second;
    dfs(left, (value << 1), depth + 1);
    dfs(right, value, depth + 1);
}
int log2(int number){
    int res = 0;
    while(number > 1){
     number >>= 1;
     ++res;
    }
    return res;
}
int cmp(pair<int, int> a, pair<int, int> b){
    int g = __gcd(a.second, b.second);
    int nok = (a.second * b.second) / g;
    a.first *= nok / a.second;
    b.first *= nok / b.second;
    return a.first > b.first;
}
pair<int, int> suming(pair<int, int> a, pair<int, int> b){
    int g = __gcd(a.second, b.second);
    int nok = (a.second * b.second) / g;
    a.first *= nok / a.second;
    b.first *= nok / b.second;
    return {a.first + b.first, nok};
}
int main(){
    cin.tie(0);
    ios::sync_with_stdio(false);
    int vertex, color;
    cin >> vertex >> color;
    for(int i = 0; i < vertex; ++i){
        int left, right;
        cin >> left;
        if(left == -1) continue;
        cin >> right;
        tree.insert({i + 1, {left, right}});
    }
    dfs(1, 1, 0);
    sort(arr.begin(), arr.end(), cmp);
    pair<int, int> sum = {0, 1};
    for(int i = 0; i < color; ++i){
        sum = suming(sum, arr[i]);
    }
    cout << fixed;
    cout << setprecision(8);
    //cout << sum.first << ' ' << sum.second << endl;
    cout << (long double)sum.first / (long double)sum.second << endl;
    return 0;
}
