#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 5e3 + 10;
int l[MAX_N], r[MAX_N], par[MAX_N];

const double ednaTreta = 0.33333333333333;
const double dveTreti = 0.66666666666666;

int dfs(int curr) {
    if(l[curr] == -1) {
        return par[curr] = 1;
    }
    return par[curr] = dfs(l[curr]) + dfs(r[curr]);
}

double solve(int curr, int left) {
    if(par[curr] < left) {
        return 0;
    }
    if(l[curr] == -left) {
        return 1;
    }
    if(left == 0) {
        return 0;
    }
    double mxAns = 0;
    for(int i = 0; i <= par[l[curr]] && i <= left; i ++) {
        double a, b;
        a = solve(l[curr], i);
        b = solve(r[curr], left - i);
        mxAns = max(mxAns, dveTreti * max(a, b) + ednaTreta * min(a, b));
    }
    //cout << curr << " " << left << " " << mxAns << endl;
    return mxAns;

}

int main() {
    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= n; i ++) {
        cin >> l[i];
        if(l[i] != -1) {
            cin >> r[i];
        }
    }
    dfs(1);
    cout << solve(1, m);
}
