#include<iostream>
#include<queue>
#include<algorithm>
#include<vector>
#include<iomanip>
using namespace std;

const long long BIGNUM = 10;


int n, m, l, r, v, u, maxim;
long long cqla;
long double drobna;

int sys[5005][2], dad[5005];

queue<int> lista;

pair<int, int> dt;
vector<pair<int, int> > masiv;


bool cmp(pair<int, int> a, pair<int, int> b)
{
    long long razlika = 0;
    pair<int, int> a1, b1;
    a1 = a;
    b1 = b;
    long long fir = 1, sec = 1;
    if(a1.first < b1.first){
        swap(a1, b1);
    }
    if(a1.second > b1.second){
        a1.second -= b1.second;
        b1.second = 0;
    }else{
        return false;
    }
    for(int i = 0; i < a1.second; i++){
        fir *= 2;
    }
    for(int i = 0; i < a1.first - b1.first; i++){
        sec *= 3;
    }

    return fir > sec;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        cin >> l;
        if(l == -1){
            sys[i][0] = -1;
            lista.push(i);
            continue;
        }
        cin >> r;
        sys[i][0] = l;
        sys[i][1] = r;
        dad[l] = i;
        dad[r] = i;
    }
    while(!lista.empty()){
        v = lista.front();
        lista.pop();
        u = v;
        dt.first = 0;
        dt.second = 0;
        while(dad[u] != 0){
            if(u == sys[dad[u]][0]){
                dt.first++;
                dt.second++;
            }else{
                dt.first++;
            }
            u = dad[u];
        }
        masiv.push_back(dt);
    }
    sort(masiv.begin(), masiv.end(), cmp);
    long double izh = 0;
    for(int i = 0; i < m; i++){
        maxim = max(maxim, masiv[i].first);
    }
    for(int i = 0; i < m; i++){
        long double curr = 1;
        dt = masiv[i];
        for(int j = 0; j < dt.second; j++){
            curr *= 2;
        }
        for(int j = 0; j < maxim - dt.first; j++){
            curr *= 3;
            if(curr > BIGNUM){
                curr /= 3;
                drobna = drobna/3 + (long double)cqla/3 - (long long)cqla/3;
                cqla /= 3;
                maxim --;
                j --;
            }
        }
        while(maxim < dt.first){
            curr /= 3;
            dt.first--;
        }
        //cout << dt.second << " " << dt.first << endl;
        /*for(int j = 0; j < dt.first; j++){
            curr /= 3;
        }*/
        cqla += (long long)curr;
        drobna = drobna + curr - (long long)curr;
        while(drobna >= 1){
            drobna -= 1;
            cqla += 1;
        }
        if(cqla > BIGNUM){
            drobna = drobna/3 + (long double)cqla/3 - (long long)cqla/3;
            cqla /= 3;
            maxim --;
        }
    }
    izh = (long double)cqla + drobna;
    while(maxim > 0){
        izh /= 3;
        maxim --;
    }

    fixed(cout);
    cout << setprecision(9) << izh << endl;
return 0;
}
/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1

13 4
2 3
4 5
6 7
8 9
10 11
-1
12 13
-1
-1
-1
-1
-1
-1
*/
