#include<algorithm>
#include<iostream>
#include<iomanip>
#include<vector>
#include<set>
using namespace std;

int tree[10005];
set<int> leaves;
vector< pair<long long,long long> > drobi;

bool cmp(pair<int,int> x,pair<int,int> y)
{
    long long zn=1ll*x.second/(__gcd(x.second,y.second))*y.second;
    long long ch1=1ll*zn/x.second*x.first,ch2=1ll*zn/y.second*y.first;
    if(ch1>=ch2) return true;
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n,m;
    cin >> n >> m;

    tree[1]=1;

    int a,b;
    int maxi=0;
    for(int i=1; i<=n; i++)
    {
        cin >> a;
        if(a==-1)
        {
            tree[i*2]=tree[i*2+1]=-1;
            leaves.insert(tree[i]);
        }
        else
        {
            cin >> b;
            tree[2*i]=a;
            tree[2*i+1]=b;
            maxi=2*i+1;
        }
    }

    int j;
    long long ch,zn;
    for(int i=maxi; i>=1; i--)
    {
        if(leaves.find(tree[i])!=leaves.end())
        {
            j=i;
            ch=zn=1;
            while(j!=1)
            {
                zn*=3;
                if(j%2==0) ch*=2;
                j/=2;
            }
            drobi.push_back({ch,zn});
        }
    }

    sort(drobi.begin(),drobi.end(),cmp);

    ch=0;
    zn=1;
    long long zn1,ch1,ch2,nod;
    for(int i=0; i<m; i++)
    {
        zn1=1ll*zn/(__gcd(zn,drobi[i].second))*drobi[i].second;
        ch1=1ll*zn1/zn*ch;
        ch2=1ll*zn1/drobi[i].second*drobi[i].first;
        ch=ch1+ch2;
        zn=zn1;
        nod=__gcd(ch,zn);
        ch/=nod;
        zn/=nod;
    }

    cout << fixed << setprecision(8) << 1.0*ch/zn << endl;

    return 0;
}
