#include<algorithm>
#include<iostream>
#include<iomanip>
#include<utility>
#include<vector>
using namespace std;

// 30% balansirano
vector< pair<unsigned long long,unsigned long long> > drobi;

bool cmp(pair<int,int> x,pair<int,int> y)
{
    unsigned long long zn=1ll*x.second/(__gcd(x.second,y.second))*y.second;
    unsigned long long ch1=1ll*zn/x.second*x.first,ch2=1ll*zn/y.second*y.first;
    if(ch1>=ch2) return true;
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n,m;
    cin >> n >> m;

    int a=(n+1)/2,b=n;
    int j;
    unsigned long long ch,zn;
    for(int i=a; i<=b; i++)
    {
        j=i;
        ch=zn=1;
        while(j!=1)
        {
            zn*=3;
            if(j%2==0) ch*=2;
            j/=2;
        }
        drobi.push_back(make_pair(ch,zn));
    }

    sort(drobi.begin(),drobi.end(),cmp);

    ch=0;
    zn=1;
    unsigned long long zn1,ch1,ch2,nod;
    for(int i=0; i<m; i++)
    {
        zn1=1ll*zn/(__gcd(zn,drobi[i].second))*drobi[i].second;
        ch1=1ll*zn1/zn*ch;
        ch2=1ll*zn1/drobi[i].second*drobi[i].first;
        ch=ch1+ch2;
        zn=zn1;
        nod=__gcd(ch,zn);
        ch/=nod;
        zn/=nod;
    }

    cout << fixed << setprecision(9) << 1.0*ch/zn << endl;

    return 0;
}
