#include <bits/stdc++.h>

using namespace std;

struct Node
{
    int v;
    double tg;
    Node(){}
    Node(int a, double b)
    {
        v = a;
        tg = b;
    }
};

vector<Node> G[5001];
double dist[5001], lt = 2.0 / 3.0, rt = 1.0 / 3.0, otg;
bool used[5001];
priority_queue<Node> pq;
int lista[5001];
int n, m, a, b, j = 0;

bool operator < (Node a, Node b)
{
    return a.tg < b.tg;
}

bool cmp(int a, int b)
{
    return dist[a] > dist[b];
}

void Deextra(int s)
{
    pq.push(Node(s, 1));
    dist[s] = 1;

    while(!pq.empty())
    {
        s = pq.top().v;
        pq.pop();

        if(used[s]) continue;

        used[s] = 1;
        for(int i = 0; i < G[s].size(); i++)
        {
            int v1 = G[s][i].v;
            double tg1 = G[s][i].tg;
            if(!used[v1] && dist[s] * tg1 > dist[v1])
            {
                dist[v1] = dist[s] * tg1;
                pq.push(Node(v1, dist[v1]));
            }
        }
    }
}

int main()
{
    string s;

    cin >> n >> m;

    for(int i = 1; i <= n; i++)
    {
        getline(cin, s);
        if(i == 1) getline(cin, s);
        if(s != "-1")
        {
            j = 0;
            while(s[j] != ' ')
            {
                a = a * 10 + (s[j] - '0');
                j++;
            }
            j++;
            for(j; j < s.size(); j++) b = b * 10 + (s[j] - '0');
            G[i].push_back(Node(a, lt));
            G[i].push_back(Node(b, rt));
        }
        else lista[j] = i, j++;
        a = 0;
        b = 0;
    }

    Deextra(1);

    sort(lista, lista + j, cmp);

    for(int i = 0; i < m; i++)
    {
        otg += dist[lista[i]];
    }

    cout << setprecision(8) << fixed << otg << endl;
}
/*
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/
