#include<bits/stdc++.h>
using namespace std;

const int MAXN = 5000;

struct leave{
    bool isleave;
    float chance;
};

int n, m;
float ans;
leave leaves[MAXN];
vector<int> G[MAXN];

bool cmp(leave a, leave b){
    return a.chance > b.chance;
}

void bfs(){
    queue<int> q;
    q.push(1);
    while(!q.empty()){
        int s = q.front();
        /// cout << s << endl;
        q.pop();
        for(int i = 0; i < G[s].size(); i ++){
            if(i == 0){
                leaves[G[s][i]].chance = leaves[s].chance * 2/3;
                /// cout << "___" << G[s][i] << " = " << leaves[G[s][i]].chance << endl;
            }
            else if(i == 1){
                leaves[G[s][i]].chance = leaves[s].chance * 1/3;
                /// cout << "___" << G[s][i] << " = " << leaves[G[s][i]].chance << endl;
            }
            q.push(G[s][i]);
        }
    }
}

int main(){
    cout << fixed;
    cin >> n >> m;
    leaves[1].chance = 1;
    for(int i = 1; i <= n; i ++){
        int a, b;
        cin >> a;
        if(a == -1){
            leaves[i].isleave = 1;
            continue;
        }
        cin >> b;
        G[i].push_back(a);
        G[i].push_back(b);
    }
    bfs();
    sort(leaves, leaves + n, cmp);
    for(int i = 2; i <= n; i ++){
        if(leaves[i].isleave == 1 && m > 0){
            m --;
            ans += leaves[i].chance;
        }
        if(m == 0){
            break;
        }
    }
    cout << setprecision(8) << ans << endl;
}
/**
15 4
2 3
4 5
6 7
8 9
10 11
12 13
14 15
-1
-1
-1
-1
-1
-1
-1
-1
*/
